'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames2 = require('classnames');

var _classnames3 = _interopRequireDefault(_classnames2);

var _CSSClassnames = require('../../../utils/CSSClassnames');

var _CSSClassnames2 = _interopRequireDefault(_CSSClassnames);

var _Intl = require('../../../utils/Intl');

var _Intl2 = _interopRequireDefault(_Intl);

var _Props = require('../../../utils/Props');

var _Props2 = _interopRequireDefault(_Props);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } // (C) Copyright 2014-2015 Hewlett Packard Enterprise Development LP

var CLASS_ROOT = _CSSClassnames2.default.CONTROL_ICON;
var COLOR_INDEX = _CSSClassnames2.default.COLOR_INDEX;

var Icon = function (_Component) {
  _inherits(Icon, _Component);

  function Icon() {
    _classCallCheck(this, Icon);

    return _possibleConstructorReturn(this, (Icon.__proto__ || Object.getPrototypeOf(Icon)).apply(this, arguments));
  }

  _createClass(Icon, [{
    key: 'render',
    value: function render() {
      var _classnames;

      var _props = this.props,
          className = _props.className,
          colorIndex = _props.colorIndex;
      var _props2 = this.props,
          a11yTitle = _props2.a11yTitle,
          size = _props2.size,
          responsive = _props2.responsive;
      var intl = this.context.intl;


      var classes = (0, _classnames3.default)(CLASS_ROOT, CLASS_ROOT + '-access-tty', className, (_classnames = {}, _defineProperty(_classnames, CLASS_ROOT + '--' + size, size), _defineProperty(_classnames, CLASS_ROOT + '--responsive', responsive), _defineProperty(_classnames, COLOR_INDEX + '-' + colorIndex, colorIndex), _classnames));

      a11yTitle = a11yTitle || _Intl2.default.getMessage(intl, 'access-tty');

      var restProps = _Props2.default.omit(this.props, Object.keys(Icon.propTypes));
      return _react2.default.createElement(
        'svg',
        _extends({}, restProps, { version: '1.1', viewBox: '0 0 24 24', width: '24px', height: '24px', role: 'img', className: classes, 'aria-label': a11yTitle }),
        _react2.default.createElement('path', { fillRule: 'evenodd', d: 'M16.2532072,4.86987861 L16.2532072,6.27515038 C16.2532072,6.66874947 16.5730064,6.98854874 16.9666055,6.98854874 L21.1424459,6.98854874 C21.53912,6.98854874 21.8558443,6.66874947 21.8558443,6.27515038 L21.8558443,4.86987861 L16.2532072,4.86987861 L16.2532072,4.86987861 Z M21.8506044,9.42207306 L19.7134844,9.42207306 C19.3936851,9.42207306 19.1415357,9.67729748 19.1415357,9.99094676 L19.1415357,11.5530432 C19.1415357,11.8697674 19.3936851,12.1219169 19.7134844,12.1219169 L21.8506044,12.1219169 C22.1642537,12.1219169 22.4225531,11.8697674 22.4225531,11.5530432 L22.4225531,9.99094676 C22.4225531,9.67729748 22.1642537,9.42207306 21.8506044,9.42207306 M21.8506044,17.4896748 L19.7134844,17.4896748 C19.3936851,17.4896748 19.1415357,17.7418242 19.1415357,18.0616234 L19.1415357,19.6206449 C19.1415357,19.9342941 19.3936851,20.1925935 19.7134844,20.1925935 L21.8506044,20.1925935 C22.1642537,20.1925935 22.4225531,19.9342941 22.4225531,19.6206449 L22.4225531,18.0616234 C22.4225531,17.7418242 22.1642537,17.4896748 21.8506044,17.4896748 M19.574199,21.3032312 L4.73428317,21.3032312 C4.4206339,21.3032312 4.16233449,21.5553806 4.16233449,21.8690299 L4.16233449,23.4342013 C4.16233449,23.7478506 4.4206339,24 4.73428317,24 L19.574199,24 C19.8878483,24 20.1399977,23.7478506 20.1399977,23.4342013 L20.1399977,21.8690299 C20.1399977,21.5553806 19.8878483,21.3032312 19.574199,21.3032312 M5.28037784,19.6215543 L5.28037784,18.0594578 C5.28037784,17.7427336 5.02207844,17.4905842 4.70842916,17.4905842 L2.56515909,17.4905842 C2.25458481,17.4905842 2.00243539,17.7427336 2.00243539,18.0594578 L2.00243539,19.6215543 C2.00243539,19.9352035 2.25458481,20.1935029 2.56515909,20.1935029 L4.70842916,20.1935029 C5.02207844,20.1935029 5.28037784,19.9352035 5.28037784,19.6215543 M2.5657987,12.1219422 L4.70906877,12.1219422 C5.02271804,12.1219422 5.28101745,11.8697927 5.28101745,11.5530685 L5.28101745,9.99097207 C5.28101745,9.67732279 5.02271804,9.42209837 4.70906877,9.42209837 L2.5657987,9.42209837 C2.25214942,9.42209837 2,9.67732279 2,9.99097207 L2,11.5530685 C2,11.8697927 2.25214942,12.1219422 2.5657987,12.1219422 M3.04611255,6.98975413 L7.21887795,6.98975413 C7.61555203,6.98975413 7.9353513,6.66995487 7.9353513,6.27635577 L7.9353513,4.87108401 L2.33271419,4.87108401 L2.33271419,6.27635577 C2.33271419,6.66995487 2.64943846,6.98975413 3.04611255,6.98975413 M17.5683935,9.42207306 L15.4251234,9.42207306 C15.1114741,9.42207306 14.8593247,9.67729748 14.8593247,9.99094676 L14.8593247,11.5530432 C14.8593247,11.8697674 15.1114741,12.1219169 15.4251234,12.1219169 L17.5683935,12.1219169 C17.8820427,12.1219169 18.1341921,11.8697674 18.1341921,11.5530432 L18.1341921,9.99094676 C18.1341921,9.67729748 17.8820427,9.42207306 17.5683935,9.42207306 M20.3011521,15.60372 L20.3011521,14.0416236 C20.3011521,13.7279743 20.0428527,13.4727499 19.7292034,13.4727499 L17.5859333,13.4727499 C17.275359,13.4727499 17.0232096,13.7279743 17.0232096,14.0416236 L17.0232096,15.60372 C17.0232096,15.9235192 17.275359,16.1756686 17.5859333,16.1756686 L19.7292034,16.1756686 C20.0428527,16.1756686 20.3011521,15.9235192 20.3011521,15.60372 M15.4242138,20.1922491 L17.5674839,20.1922491 C17.8811332,20.1922491 18.1332826,19.9339497 18.1332826,19.6203004 L18.1332826,18.061279 C18.1332826,17.7414798 17.8811332,17.4893303 17.5674839,17.4893303 L15.4242138,17.4893303 C15.1105645,17.4893303 14.8584151,17.7414798 14.8584151,18.061279 L14.8584151,19.6203004 C14.8584151,19.9339497 15.1105645,20.1922491 15.4242138,20.1922491 M16.0127429,15.60372 L16.0127429,14.0416236 C16.0127429,13.7279743 15.7605935,13.4727499 15.4407942,13.4727499 L13.3036741,13.4727499 C12.9930998,13.4727499 12.7348004,13.7279743 12.7348004,14.0416236 L12.7348004,15.60372 C12.7348004,15.9235192 12.9930998,16.1756686 13.3036741,16.1756686 L15.4407942,16.1756686 C15.7605935,16.1756686 16.0127429,15.9235192 16.0127429,15.60372 M11.136148,20.1922491 L13.2794181,20.1922491 C13.5930673,20.1922491 13.8513667,19.9339497 13.8513667,19.6203004 L13.8513667,18.061279 C13.8513667,17.7414798 13.5930673,17.4893303 13.2794181,17.4893303 L11.136148,17.4893303 C10.8224987,17.4893303 10.5703493,17.7414798 10.5703493,18.061279 L10.5703493,19.6203004 C10.5703493,19.9339497 10.8224987,20.1922491 11.136148,20.1922491 M13.2803039,12.1219422 C13.5939531,12.1219422 13.8522525,11.8697927 13.8522525,11.5530685 L13.8522525,9.99097207 C13.8522525,9.67732279 13.5939531,9.42209837 13.2803039,9.42209837 L11.1370338,9.42209837 C10.8233845,9.42209837 10.5712351,9.67732279 10.5712351,9.99097207 L10.5712351,11.5530685 C10.5712351,11.8697927 10.8233845,12.1219422 11.1370338,12.1219422 L13.2803039,12.1219422 L13.2803039,12.1219422 Z M11.7308028,15.60372 L11.7308028,14.0416236 C11.7308028,13.7279743 11.4725034,13.4727499 11.1588541,13.4727499 L9.01558403,13.4727499 C8.70500974,13.4727499 8.45286032,13.7279743 8.45286032,14.0416236 L8.45286032,15.60372 C8.45286032,15.9235192 8.70500974,16.1756686 9.01558403,16.1756686 L11.1588541,16.1756686 C11.4725034,16.1756686 11.7308028,15.9235192 11.7308028,15.60372 M6.88397442,20.1922491 L9.02724449,20.1922491 C9.34089377,20.1922491 9.59304318,19.9339497 9.59304318,19.6203004 L9.59304318,18.061279 C9.59304318,17.7414798 9.34089377,17.4893303 9.02724449,17.4893303 L6.88397442,17.4893303 C6.57032514,17.4893303 6.31817572,17.7414798 6.31817572,18.061279 L6.31817572,19.6203004 C6.31817572,19.9339497 6.57032514,20.1922491 6.88397442,20.1922491 M8.99804417,12.1219422 C9.31169344,12.1219422 9.56384286,11.8697927 9.56384286,11.5530685 L9.56384286,9.99097207 C9.56384286,9.67732279 9.31169344,9.42209837 8.99804417,9.42209837 L6.8547741,9.42209837 C6.54112482,9.42209837 6.2889754,9.67732279 6.2889754,9.99097207 L6.2889754,11.5530685 C6.2889754,11.8697927 6.54112482,12.1219422 6.8547741,12.1219422 L8.99804417,12.1219422 L8.99804417,12.1219422 Z M4.16326979,14.0422633 L4.16326979,15.6043597 C4.16326979,15.9210839 4.4215692,16.1732334 4.73521847,16.1732334 L6.87233856,16.1732334 C7.18906283,16.1732334 7.44121225,15.9210839 7.44121225,15.6043597 L7.44121225,14.0422633 C7.44121225,13.728614 7.18906283,13.4733896 6.87233856,13.4733896 L4.73521847,13.4733896 C4.4215692,13.4733896 4.16326979,13.728614 4.16326979,14.0422633 M7.93508079,4.31114008 C7.93508079,3.90524101 8.27640501,3.20721762 12.0924712,3.19491765 C15.9116124,3.18261768 16.2529366,3.90524101 16.2529366,4.31114008 L16.2529366,4.42798981 L21.8555738,4.42798981 L21.8555738,4.28039015 C21.8555738,3.55161683 20.5425518,0 12.0924712,0 C3.64546566,0 2.33244368,3.55161683 2.33244368,4.28039015 L2.33244368,4.42798981 L7.93508079,4.42798981 L7.93508079,4.31114008 L7.93508079,4.31114008 Z' })
      );
    }
  }]);

  return Icon;
}(_react.Component);

Icon.displayName = 'Icon';
exports.default = Icon;
;

Icon.contextTypes = {
  intl: _propTypes2.default.object
};

Icon.defaultProps = {
  responsive: true
};

Icon.displayName = 'AccessTty';

Icon.icon = true;

Icon.propTypes = {
  a11yTitle: _propTypes2.default.string,
  colorIndex: _propTypes2.default.string,
  size: _propTypes2.default.oneOf(['xsmall', 'small', 'medium', 'large', 'xlarge', 'huge']),
  responsive: _propTypes2.default.bool
};
module.exports = exports['default'];