'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames2 = require('classnames');

var _classnames3 = _interopRequireDefault(_classnames2);

var _CSSClassnames = require('../../../utils/CSSClassnames');

var _CSSClassnames2 = _interopRequireDefault(_CSSClassnames);

var _Intl = require('../../../utils/Intl');

var _Intl2 = _interopRequireDefault(_Intl);

var _Props = require('../../../utils/Props');

var _Props2 = _interopRequireDefault(_Props);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } // (C) Copyright 2014-2015 Hewlett Packard Enterprise Development LP

var CLASS_ROOT = _CSSClassnames2.default.CONTROL_ICON;
var COLOR_INDEX = _CSSClassnames2.default.COLOR_INDEX;

var Icon = function (_Component) {
  _inherits(Icon, _Component);

  function Icon() {
    _classCallCheck(this, Icon);

    return _possibleConstructorReturn(this, (Icon.__proto__ || Object.getPrototypeOf(Icon)).apply(this, arguments));
  }

  _createClass(Icon, [{
    key: 'render',
    value: function render() {
      var _classnames;

      var _props = this.props,
          className = _props.className,
          colorIndex = _props.colorIndex;
      var _props2 = this.props,
          a11yTitle = _props2.a11yTitle,
          size = _props2.size,
          responsive = _props2.responsive;
      var intl = this.context.intl;


      var classes = (0, _classnames3.default)(CLASS_ROOT, CLASS_ROOT + '-platform-suse', className, (_classnames = {}, _defineProperty(_classnames, CLASS_ROOT + '--' + size, size), _defineProperty(_classnames, CLASS_ROOT + '--responsive', responsive), _defineProperty(_classnames, COLOR_INDEX + '-' + colorIndex, colorIndex), _classnames));

      a11yTitle = a11yTitle || _Intl2.default.getMessage(intl, 'platform-suse');

      var restProps = _Props2.default.omit(this.props, Object.keys(Icon.propTypes));
      return _react2.default.createElement(
        'svg',
        _extends({}, restProps, { version: '1.1', viewBox: '0 0 24 24', width: '24px', height: '24px', role: 'img', className: classes, 'aria-label': a11yTitle }),
        _react2.default.createElement('path', { fillRule: 'evenodd', d: 'M1.4077754,14.4249064 C0.630814744,14.4249064 0,15.0266688 0,15.7669982 L0,16.1631205 C0,16.8737661 0.529510494,17.3698032 1.28727134,17.3698032 L2.69807828,17.3698032 C2.88944479,17.3698032 3.08384285,17.4846231 3.08384285,17.7041578 L3.08384285,18.0693331 C3.08384285,18.2748468 2.88312906,18.4022982 2.69807828,18.4022982 L0.0646730375,18.4022982 L0.0646730375,19.0265445 C0.0646730375,19.2679316 0.266649965,19.4430035 0.542899834,19.4430035 L2.88287643,19.4430035 C3.6660265,19.4430035 4.30202014,18.8398517 4.30202014,18.0996486 L4.30202014,17.5686223 C4.30202014,16.8469874 3.83693005,16.4338126 3.02611711,16.4338126 L1.62642584,16.4338126 C1.38289143,16.4338126 1.21880886,16.3090138 1.21880886,16.1208052 L1.21880886,15.808682 C1.21880886,15.6284312 1.42836466,15.4651065 1.65863605,15.4651065 L3.91612926,15.4651065 L3.91612926,14.8402285 C3.91612926,14.5798943 3.76328868,14.4249064 3.50724914,14.4249064 L1.4077754,14.4249064 M8.86637028,15.6781738 C8.61879381,15.6781738 8.44637448,15.8661298 8.44637448,16.135685 L8.44637448,17.9746982 C8.44637448,18.2109064 8.24376598,18.4022729 7.99543162,18.4022729 L6.73696,18.4022729 C6.48900458,18.4022729 6.28614345,18.2109064 6.28614345,17.9746982 L6.28614345,16.135685 C6.28614345,15.8749719 6.0030726,15.6781738 5.75069618,15.6781738 L5.4986987,15.6781738 C5.25112223,15.6781738 5.07794501,15.8661298 5.07794501,16.135685 L5.07794501,18.0484659 C5.07794501,18.9535095 5.66341284,19.4740516 6.68226581,19.4740516 L6.84710627,19.4740516 C7.32242783,19.4740516 7.71615021,19.277001 8.00313681,19.1326235 C8.1691141,19.0502664 8.30073383,18.9843302 8.38877506,18.9843302 C8.42111158,18.9843302 8.49930027,18.9905196 8.54060512,19.0502664 L8.82708647,19.4431046 L9.21967201,19.4431046 C9.53823725,19.4431046 9.65394136,19.187444 9.65394136,19.0161615 L9.65394136,16.135685 C9.65394136,15.8749719 9.37099682,15.6781738 9.11836776,15.6781738 L8.86637028,15.6781738 M11.8641171,14.4249064 C11.0886723,14.4249064 10.4567207,15.0266688 10.4567207,15.7669982 L10.4567207,16.1631205 C10.4567207,16.8737661 10.9863575,17.3698032 11.7448762,17.3698032 L13.1555569,17.3698032 C13.3469234,17.3698032 13.5411951,17.4846231 13.5411951,17.7041578 L13.5411951,18.0693331 C13.5411951,18.2748468 13.3398498,18.4022982 13.1555569,18.4022982 L10.5222779,18.4022982 L10.5222779,19.0265445 C10.5222779,19.2679316 10.723497,19.4430035 11.0007574,19.4430035 L13.3404813,19.4430035 C14.1228735,19.4430035 14.7589935,18.8398517 14.7589935,18.0996486 L14.7589935,17.5686223 C14.7589935,16.8469874 14.2937771,16.4338126 13.4825852,16.4338126 L12.0828939,16.4338126 C11.8397384,16.4338126 11.6761611,16.3090138 11.6761611,16.1208052 L11.6761611,15.808682 C11.6761611,15.6284312 11.885338,15.4651065 12.1153567,15.4651065 L14.431081,15.4651065 L14.431081,14.8402285 C14.431081,14.595431 14.2397144,14.4249064 13.9646014,14.4249064 L11.8641171,14.4249064 M16.7679376,15.8400206 C16.7679376,15.6326122 16.946799,15.4651191 17.1650705,15.4651191 L18.5640038,15.4651191 C18.7826543,15.4651191 18.9610104,15.6326122 18.9610104,15.8400206 L18.9610104,16.4338252 L16.7679376,16.4338252 L16.7679376,15.8400206 L16.7679376,15.8400206 Z M16.9680198,14.424919 C16.1925749,14.424919 15.5601181,15.0266814 15.5601181,15.7670108 L15.5601181,18.0996612 C15.5601181,18.8398643 16.1925749,19.4430162 16.9680198,19.4430162 L18.9363791,19.4430162 C19.2133868,19.4430162 19.4141006,19.2679442 19.4141006,19.0265572 L19.4141006,18.4023108 L17.1756809,18.4023108 C16.9363148,18.4023108 16.7679376,18.244165 16.7679376,18.016041 L16.7679376,17.3808052 L19.4506055,17.3808052 C19.8467278,17.3808052 20.1690825,17.073103 20.1690825,16.6937805 L20.1690825,15.7673898 C20.1690825,15.0266814 19.5378888,14.424919 18.7616861,14.424919 L16.9680198,14.424919 Z M22.0289881,7.64449416 C22.2343756,7.64449416 22.4014897,7.53308474 22.4014897,7.39653874 C22.4014897,7.25936117 22.2343756,7.14820438 22.0289881,7.14820438 C21.8233481,7.14820438 21.6572445,7.25936117 21.6572445,7.39653874 C21.6572445,7.53308474 21.8233481,7.64449416 22.0289881,7.64449416 M21.8345901,8.40377077 L21.8345901,8.40377077 C21.3731631,8.38684463 21.010893,7.99754326 21.0263034,7.53523209 C21.0332507,7.31140275 21.1288708,7.10475218 21.2914376,6.95203792 C21.4548886,6.79894472 21.6679812,6.71974551 21.8916842,6.72782964 C22.3538691,6.74425053 22.7161392,7.13279401 22.7007288,7.59548412 C22.6937815,7.81893452 22.5995508,8.0257114 22.4363525,8.17905723 C22.2722699,8.33126624 22.0593036,8.41059176 21.8345901,8.40377077 M20.659486,7.53295843 C20.670728,7.21199322 20.8051267,6.91464882 21.040198,6.69637732 C21.2743852,6.47684267 21.5808242,6.36379117 21.9016631,6.37414896 C22.5641828,6.39802241 23.0838407,6.95595367 23.0612304,7.61847336 C23.0496095,7.93830174 22.9150845,8.23551982 22.6803921,8.45404396 C22.4460787,8.67395755 22.1407765,8.78738799 21.8188008,8.77652494 C21.1571653,8.75189361 20.6377599,8.1944676 20.659486,7.53295843 M23.8704013,8.71639923 C23.9244639,8.6796417 23.9655161,8.6500841 23.982316,8.644021 L24,8.61522129 C23.9540215,8.32419262 23.5215206,6.91692248 23.1949975,6.57941007 C23.1041774,6.48618995 23.0315465,6.39612769 22.8850217,6.31023381 C21.7020861,5.62080913 18.8938616,5.20422382 18.7624945,5.18515033 L18.7398842,5.19159237 L18.7312948,5.21129744 C18.7312948,5.21129744 18.7208107,5.79398635 18.7194212,5.85891201 C18.4323083,5.76303929 16.3476134,5.08953023 14.3925171,5.02157302 C12.7353969,4.96296308 10.4715879,4.88414281 7.27241991,6.8501021 L7.1784419,6.90934361 C5.67378326,7.8483658 4.63547786,9.0049016 4.09194645,10.3505303 C3.92167447,10.773305 3.69228729,11.7281165 3.91902186,12.6265917 C4.01767351,13.0203141 4.19994537,13.4142891 4.44613238,13.7675908 C5.00103209,14.5652671 5.93373856,15.0954091 6.93793904,15.1847135 C8.35480908,15.311407 9.42911413,14.6744028 9.81083663,13.4827516 C10.0735708,12.6598124 9.81083663,11.4528771 8.80461511,10.8375991 C7.9862233,10.3357515 7.10517947,10.4501924 6.59512142,10.7875785 C6.15175743,11.0816387 5.90051784,11.5377605 5.90569673,12.0393555 C5.91529664,12.9278518 6.68164687,13.4008997 7.23199926,13.4015313 C7.39254502,13.4015313 7.55283816,13.3742474 7.73435213,13.3152585 C7.79851991,13.2951745 7.85965614,13.27168 7.92635021,13.2298699 L7.94706579,13.2164805 L7.96007619,13.209028 L7.95527624,13.211049 C8.08133813,13.1265446 8.15737948,12.9870934 8.15737948,12.8379159 C8.15737948,12.7971163 8.15106375,12.7558115 8.13969545,12.714254 C8.07489609,12.4896668 7.85296147,12.3532471 7.62180589,12.3953098 L7.59085883,12.4020045 L7.54879609,12.4156464 L7.48740723,12.4362357 C7.36071376,12.4681933 7.26509366,12.470088 7.2453886,12.4708459 C7.18084188,12.4665512 6.86353979,12.3714364 6.86353979,12.0238188 L6.86353979,12.0200293 C6.86404504,11.8924517 6.91545506,11.803021 6.94337057,11.7545162 C7.04151695,11.5995283 7.31157741,11.4475719 7.67687902,11.4799084 C8.15548476,11.5205817 8.5001971,11.7663898 8.7288264,12.2292062 C8.94141374,12.6601914 8.88583535,13.1890703 8.58596467,13.5778664 C8.28824133,13.9626204 7.7584782,14.1256925 7.05339052,14.0490196 C6.34249236,13.9710835 5.74174048,13.5620771 5.40561752,12.9254519 C5.07593661,12.3033528 5.05749469,11.5652971 5.35812326,10.9981448 C6.07786343,9.63988473 7.43700774,9.65365301 8.18213713,9.78287277 C9.2853682,9.97335508 10.2867898,10.8566726 10.7320485,12.031145 C10.8032899,12.2182168 10.8397948,12.3666364 10.8714997,12.5016666 L10.9192466,12.7051593 L12.1652131,13.313869 L12.1821392,13.3253637 L12.212581,13.3223321 L12.217381,13.2864588 C12.2099284,13.2582906 12.1916128,13.2331541 12.1634447,12.884147 C12.1394449,12.5749291 12.0910665,11.7278638 12.5172517,11.3077417 C12.6825974,11.1439118 12.9351001,10.9982711 13.1342981,10.9510295 C13.9515531,10.7518315 15.0117109,10.8896407 15.9176387,11.9367881 C16.3844972,12.4780458 16.6142633,12.725117 16.7290832,12.8353896 L16.7683671,12.8720208 L16.8162403,12.9067573 C16.8537557,12.9274729 18.3725615,13.6271291 18.3725615,13.6271291 L18.4037612,13.6192976 L18.4043928,13.5862032 C18.394414,13.5748349 17.4417498,12.3441524 17.6106323,11.3302257 C17.7442731,10.522318 18.387593,10.5948225 19.2760893,10.6965057 C19.5668654,10.7298528 19.8975568,10.7674945 20.2394902,10.7751997 C21.1943017,10.7806312 22.2230072,10.605433 22.8573588,10.3284252 C23.2673757,10.148806 23.5293521,10.0308282 23.6934346,9.88152442 C23.7522972,9.83301964 23.7833706,9.7526836 23.8149492,9.66817918 L23.8366753,9.61121133 C23.8633277,9.5431278 23.9021062,9.39685558 23.9190324,9.31740374 C23.9267376,9.28190936 23.930527,9.244015 23.9055167,9.22494151 L23.8177281,9.24123608 C23.5397099,9.40809757 22.8437168,9.72615755 22.1921865,9.738789 C21.385163,9.75546252 19.7582319,8.92671291 19.5884652,8.838798 L19.5721706,8.81985082 C19.5317499,8.72284127 19.287205,8.14520494 19.235795,8.02343773 C20.406857,8.7944616 21.3780894,9.22064682 22.121703,9.28696194 C22.9490631,9.36098225 23.5945304,8.90915519 23.8704013,8.71639923' })
      );
    }
  }]);

  return Icon;
}(_react.Component);

Icon.displayName = 'Icon';
exports.default = Icon;
;

Icon.contextTypes = {
  intl: _propTypes2.default.object
};

Icon.defaultProps = {
  responsive: true
};

Icon.displayName = 'PlatformSuse';

Icon.icon = true;

Icon.propTypes = {
  a11yTitle: _propTypes2.default.string,
  colorIndex: _propTypes2.default.string,
  size: _propTypes2.default.oneOf(['xsmall', 'small', 'medium', 'large', 'xlarge', 'huge']),
  responsive: _propTypes2.default.bool
};
module.exports = exports['default'];